// Henkjan Wouterse
// Mti3b
// 15-3-2000
unit Unit1;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    HeaderControl1: THeaderControl;
    Panel2: TPanel;
    Panel3: TPanel;
    ListView1: TListView;
    Image1: TImage;
    Memo1: TMemo;
    procedure HeaderControl1Resize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
   procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     TheDir:string;
     procedure ReadDirectory;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.HeaderControl1Resize(Sender: TObject);
begin
  HeaderControl1.Sections[1].Width:=form1.clientWidth;
  HeaderControl1.Sections[1].Width:=HeaderControl1.Sections[1].Width-HeaderControl1.Sections[0].Width;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  HeaderControl1.Sections[0].Width:=form1.clientWidth;
  thedir:=extractfilepath(paramstr(0));
  readdirectory;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  panel2.Width:=HeaderControl1.Sections[0].Width;
  panel3.Width:=HeaderControl1.Sections[1].Width;
  HeaderControl1.OnResize(nil);
end;

procedure TForm1.ReadDirectory;
var S:TsearchRec;
    N:Tlistitem;
    error:integer;
begin
  ListView1.Items.Clear;
  if TheDir[length(theDir)]<>'\' then
    TheDir:=TheDir +'\';
  error:=FindFirst(TheDir+'*.*', faAnyFile,S);
  while error = 0 do
  begin
    n:=listview1.items.add;
    n.caption:=s.Name;
    if s.attr and fadirectory=0 then
      n.SubItems.add(IntToStr(s.size));
    error:=FindNext(s);
  end;
  Findclose(s);
  Edit1.text := TheDir;
end;

procedure TForm1.ListView1DblClick(Sender: TObject);
begin
  with listview1 do
  if (itemFocused <> nil) and (ListView1.ItemFocused.SubItems.Count = 0)then
  begin
    chdir(listview1.itemfocused.caption);
    getdir(0,thedir);
    setlength(thedir,1000);
    getcurrentdirectory(999,PChar(TheDir));
    Setlength(thedir,strLen(Pchar(TheDir)));
    if TheDir[Length(TheDir)]<>'\' then
       TheDir := TheDir + '\';
    readdirectory;
  end;
end;


procedure TForm1.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var e:string;
begin
  with listview1 do
  if (itemfocused <> nil) and (listview1.itemfocused.subitems.count <> 0) then
  begin
    e:= uppercase(extractfileext(itemfocused.caption));
    memo1.visible:=false;
    image1.visible:=false;
    if (e = '.cfg') or (e = '.html') or (e = '.htm') or (e = '.SYS') or (e = '.sys') or (e = '.BAT') or (e = '.bat') or (e = '.txt') or (e = '.TXT') or (e = '.pas') or (e = '.PAS') then
    begin
      memo1.visible:=true;
      memo1.lines.loadfromfile(itemfocused.caption);
    end
    else if (e = '.bmp') or (e = '.BMP') then
    begin
      image1.visible :=true;
      image1.picture.loadfromfile(itemfocused.caption);
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if OpenDialog1.execute then
 begin
   getdir(0,TheDir);
   readDirectory;
 end;
end;



end.
